﻿Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            RadListView1.DataSource = ListViewData()
            RadListView1.DataBind()
        End If

        If RadListView1.Items.Count > 0 Then
            For Each i In RadListView1.Items
                Dim rlb As Telerik.Web.UI.RadListBox = CType(i.FindControl("rlbFilters"), Telerik.Web.UI.RadListBox)
                rlb.DataSource = ListBoxData()

                If Not Page.IsCallback Then
                    rlb.DataBind()
                End If
            Next
        End If
    End Sub

    Private Sub btnTest_click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTest.Click
        'RadListView1.DataSource = ListViewData()
        'RadListView1.DataBind()
    End Sub

    Private Sub rlvFilters_ItemDataBound(ByVal sender As Object, ByVal e As Telerik.Web.UI.RadListViewItemEventArgs) Handles RadListView1.ItemDataBound
        Dim rlb As Telerik.Web.UI.RadListBox = CType(e.Item.FindControl("rlbFilters"), Telerik.Web.UI.RadListBox)
        rlb.EnableLoadOnDemand = True
        rlb.SelectionMode = Telerik.Web.UI.ListBoxSelectionMode.Multiple
        rlb.DataSource = ListBoxData()
        rlb.DataBind()
    End Sub

    Private Function ListViewData() As Item()
        Dim arr As New List(Of Item)

        Dim item1 As New Item
        item1.Name = "First"

        Dim item2 As New Item
        item2.Name = "Second"

        Dim item3 As New Item
        item3.Name = "Third"

        arr.Add(item1)
        arr.Add(item2)
        arr.Add(item3)

        Return arr.ToArray
    End Function

    Private Function ListBoxData() As FilterItem()
        Dim arr As New List(Of FilterItem)

        For x As Integer = 0 To 10000
            Dim f As New FilterItem
            f.Text = String.Format("Item {0}", x.ToString)
            f.Value = x.ToString
            arr.Add(f)
        Next

        Return arr.ToArray
    End Function

End Class

Public Class Item

    Private _name As String

    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
        End Set
    End Property

End Class

Public Class FilterItem

    Private _text As String

    Public Property Text() As String
        Get
            Return _text
        End Get
        Set(ByVal value As String)
            _text = value
        End Set
    End Property

    Private _val As String

    Public Property Value() As String
        Get
            Return _val
        End Get
        Set(ByVal value As String)
            _val = value
        End Set
    End Property

End Class